(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Courier New", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Courier New", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Courier New", 12, L0, center, nohscroll, bold;
	fontset = section, "Arial", 14, L0, bold, grayBox;
	fontset = subsection, "Arial", 12, L0, bold, blackBox;
	fontset = subsubsection, "Arial", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Arial", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65280;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Arial", 10, L0, nohscroll, italic, B65280;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Arial", 10, L0, nohscroll;
	fontset = clipboard, "Arial", 12, L0, nohscroll;
	fontset = completions, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Arial", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Arial", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; preserveAspect; startGroup; Cclosed; nohscroll; center; ]
Notebooks for
Integrated Applications
:[font = text; inactive; preserveAspect; ]
pt (novembre 1994) da John M. Novak, April 1994

:[font = text; inactive; preserveAspect; backColorRed65280; backColorGreen65280; backColorBlue65280; fontColorRed0; fontColorGreen0; fontColorBlue0; plain; fontName = "Times New Roman"; fontSize = 12; ]
The Mathematica  notebook interface is a useful tool for informing users and creating "live" documents. These characteristics allow notebooks to be used to good effect in any Mathematica-based application. A number of issues of good notebook design need to be considered in this context, including appropriate contents and portability.
:[font = subtitle; inactive; preserveAspect; startGroup; Cclosed; nohscroll; center; ]
What Should Notebooks Contain?
:[font = text; inactive; preserveAspect; ]
The notebook front end provides Mathematica with a very flexible document interface. However, in the context of a Mathematica-based application, only some of the possible ways of using the front end should be employed. A notebook in an application is best used as an expository tool, or as application documentation. Generally it is not a good idea to place the application code in notebooks (or, at least, not in notebooks intended to be opened by the user).
:[font = text; inactive; preserveAspect; ]
Mathematica applications can take many forms, so very few of the rules given here are hard and fast. However, general principles of good design suggest that you use techniques such as information hiding to simplify the interface of your application. This will usually give your users a better experience with your application, and make it more useful overall.
:[font = text; inactive; preserveAspect; ]
This principle means placing the implementation code in packages, and showing the use of those packages in the notebooks. While notebooks can be useful for documenting code as it is developed, this information is generally not useful to users; the application should not present its code in notebook form. Note that this is distinct from the case where the purpose of the notebook is to demonstrate code-development techniques; code developed in this fashion usually is less complete in some fashion than full application code, and can be presented in an interactive fashion.
:[font = text; inactive; preserveAspect; ]
Notebooks can act as live books, containing text explaining the application or employing it for problem solving. The text can be mixed with the actual examples of the use of application functions, presented so that the user can modify parameters or other aspects of the function calls. This is especially useful when the application is courseware; in many cases, the application will consist only of notebooks, with no auxiliary packages.
:[font = text; inactive; preserveAspect; endGroup; ]
A user reads a notebook for a particular purpose: to learn a concept, to solve a particular problem, or to learn how to use an application. As such, information that is extraneous to the primary objective should not be placed in the notebook. For some advanced users, implementation details become important; these users can always delve into packages, where detailed information on implementation should be placed. Again, simplify the interface for the user, and the user will thank you.
:[font = subtitle; inactive; preserveAspect; startGroup; Cclosed; nohscroll; center; ]
How Should Documents be Structured?
:[font = text; inactive; preserveAspect; ]
The hierarchical structure of the notebook allows the use of another aspect of information hiding. Essentially, you can delay presentation of various concepts until the user is ready by placing information in closed cell groups. The tree structure of cells allows you to summarize the contents of parts of the notebook in cell headings. The user can choose the heading of interest, where the topic will be expanded upon.
:[font = text; inactive; preserveAspect; ]
You can model the presentation of information in a notebook the same way you would a book, with chapters, sections, subsections, and so forth. To reduce the amount of information presented to the user at once (and, incidentally, to reduce memory consumption so users with smaller machines can handle the documents), it is often a good idea to place separate "chapters" in separate notebooks.
:[font = text; inactive; preserveAspect; ]
The information-hiding technique is particularly useful in courseware that contains problem sets. The problem can be presented in a cell visible to the student, with the answer in a closed cell that the student opens after solving the problem. (This technique has been used in many of the popular instances of calculus courseware.)
:[font = text; inactive; preserveAspect; ]
The live input in a notebook must be carefully handled. For instance, do not use direct references to items in the command history (e.g., %52, Out[5]). In general, the user's session will not match your session. Relative references are acceptable in a close-knit group of computations (e.g., %, %%). Generally it is not good to refer to anything more than three prior computations back, and ideally all the code referred to in this fashion should be on-screen at once. For more distant references, assign output to descriptive symbols, and reference those symbols in the later calculations. If it is likely that the user may not be able to easily locate the prior reference, document it in the text or reenter the definition.
:[font = text; inactive; preserveAspect; ]
The typical application notebook contains a brief summary of the purpose and/or the contents of the notebook after the title. This portion of the document is usually grouped so that it is visible when the title is visible. Some initialization code may be placed after the introduction. If it is simple (e.g., loading a package) it may be visible to the user. If it is more complex, and less relevant to the purpose of the notebook (e.g., setting font styles for graphics, setting paths), it may be in a closed group or cell. Initialization material of this sort should go in initialization cells. Finally, the text of the document is given, divided into appropriate sections.
:[font = text; inactive; preserveAspect; endGroup; ]
These principles are essentially "rules of thumb" for clear notebooks; they will not apply to every notebook. Further, as more capabilities are added to future versions of the notebook front end, the straightforward tree structure may become less applicable. Keep in mind that the goal is to make information accessible to the user.
:[font = subtitle; inactive; preserveAspect; startGroup; Cclosed; nohscroll; center; ]
How Do You Create Portable Notebooks?
:[font = text; inactive; preserveAspect; ]
The notebook format is essentially portable across the various platforms that have notebook front ends. However, some aspects of the portability are limited. Generally, the text, code, and graphics created in Mathematica on one platform will be readable and useable on another. However, the style of the notebook may not be identical, and imported graphics may not transport. Some of the points to keep in mind if a notebook is intended to be ported while maintaining a substantially similar appearance are described in this section.
:[font = text; inactive; preserveAspect; ]
There are two major types of Mathematica notebook front ends: those based on the Macintosh version of the front  end (which currently includes the Power Macintosh, NeXT and X Windows front ends), and those based on the Microsoft Windows version of the front end (including all versions for Windows NT). Both of these systems are continually growing and adding new features, so the information given here is subject to change. This information was current for Version 2.2. For convenience, front ends based on the Macintosh will be referred to as "Mac-style" front ends, while those based on MS Windows will be referred to as "Win-style" front ends.
:[font = subsubtitle; inactive; preserveAspect; startGroup; Cclosed; nohscroll; center; ]
Fonts
:[font = text; inactive; preserveAspect; ]
Fonts are the biggest problem in cross-platform notebook compatibility. The first problem of this type comes from fonts that do not exist on the target machine. For maximum compatibility, use only fonts that are virtually guaranteed to exist on all machines; Times and Courier are good choices.
:[font = text; inactive; preserveAspect; ]
A major portability problem arises from use of extended character sets. Most systems support extended character sets for a given font, allowing, for instance, characters with umlauts, or a subset of Greek characters. (Technically, these are characters above ASCII 127.) In general, these character sets are not identical across platforms. The characters will be incorrect when the notebook is opened on another platform. This is especially a problem with Macintosh and NeXT notebooks, since users of these platforms are used to drawing upon extended character sets. Unfortunately, there is currently no solution for this problem. To work aound it you should spell out Greek characters in a Mathematica-like notation (e.g., Pi).
:[font = text; inactive; preserveAspect; ]
Multiple-font cells are not currently portable to the Win-style front ends. While a notebook with multiple fonts in a given cell can be read by the Windows front end, the front end will use whatever font has been assigned to the entire cell for all characters. Use of styles to indicate other fonts for particular words in a cell is ignored. (Thus, italicization of Mathematica does not occur.) This will eventually be corrected in a future version of Mathematica for Windows. Multiple-font cells generally move well between Mac-style front ends.
:[font = text; inactive; preserveAspect; endGroup; ]
Note that in the current version of Mac-style front ends, tabs are not correctly handled in multi-font cells. In the MS Windows front end, tabs cannot be reset, they are automatically equivalent to 8 spaces. In Mac-style front ends, tab size can be set, but this applies to the front end as a whole, not the notebook. This can cause alignment problems when notebooks are moved between platforms. In general, you should use only multiple spaces, not tabs, to align text at the current time. (This works best, of course, when monospaced fonts such as "Courier" are involved.)
:[font = subsubtitle; inactive; preserveAspect; startGroup; Cclosed; nohscroll; center; ]
Graphics
:[font = text; inactive; preserveAspect; ]
Most graphics created as Mathematica output should be completely portable. The only known exceptions are top-level Mathematica commands that generate raw PostScript (e.g., the Arrow primitive from the Graphics`Arrow` package).
:[font = text; inactive; preserveAspect; ]
Some authors may consider modifications to color to be a problem. Often when graphics are moved between platforms (or even between different computers with the same architecture) colors with an identical specification in Mathematica appear different on the screen. Generally, this is unavoidable. Good color-correction routines for a particular system may minimize this distortion, but some differences will usually occur.
:[font = text; inactive; preserveAspect; ]
Graphics generated outside of Mathematica and pasted into a notebook are the greatest problem. First note that most externally generated graphics are kept only in the binary portion of a notebook, which is not portable. This means that such graphics are lost when the notebook is moved.
:[font = text; inactive; preserveAspect; ]
In general, it is best to avoid the use of externally generated graphics in a notebook, unless you are on a platform that will allow you to successfully convert to PostScript. If you are, such conversion should be performed immediately on import of the graphic.
:[font = text; inactive; preserveAspect; ]
Certain kinds of machine-specific graphics will probably not convert well at all. QuickTime animations from a Macintosh are a good example.
:[font = text; inactive; preserveAspect; ]
You may occasionally encounter problems with fonts in graphics. Most problems are identical to those explained in the preceding section. However, fonts in graphics usually require more precise placement.
:[font = text; inactive; preserveAspect; endGroup; ]
There is a difference in graphics positioning between Mac-style front ends and the Win-style front ends. In the Windows front end, graphics are positioned with respect to the left page margin, while in the Macintosh front end, they are positioned with respect to the left cell margin. (Note that the Windows front end does not currently support cell margins.) This causes graphics to be incorrectly positioned on the screen in a ported notebook. You may need to reposition graphics by hand in some cases for ideal appearance. It is possible to create automated routines to convert notebook files that will work for most cases. This involves tranforming notebook cell header lines.
:[font = subsubtitle; inactive; preserveAspect; startGroup; Cclosed; nohscroll; center; ]
Other Issues
:[font = text; inactive; preserveAspect; ]
The MS Windows version does not currently support cell-based margins, and the document margins are sometimes unreliable. Furthermore, they are stored in the binary portion of the notebook. All of this means that a notebook created in a Win-style front end will adopt the default margins of the target platform, which are usually suitable, but are rarely, if ever, identical. Conversely, margins specified in a Mac-style front end will not be used in a notebook ported to MS Windows. There is currently no solution to this difference of front end capabilities.
:[font = text; inactive; preserveAspect; ]
None of the front ends store page headers in the notebook text portion, so this is not portable. Also, the Win-style front ends do not currently allow you to use tabs in the running head to specify left, center, and right alignment. If notebooks are intended to be printed by the user, be aware that some characteristics will not be identical across platforms (or even across Mathematica installations).
:[font = text; inactive; preserveAspect; ]
All front ends are supposed to correctly handle notebooks using carriage-return(cr)/linefeed(lf) [MS-DOS style], cr [Macintosh style], and lf [Unix style] end-of-line indicators. However, problems have been encountered porting notebooks to the Macintosh and NeXT that can only be explained by incorrect handling of cr/lf, so currently you should run any notebook transported from a Win-style front end to other platforms through a file filter to convert to the correct end-of-line marker. Transferring a file by FTP using ASCII mode is generally a sufficient correction; Apple File Exchange can also be used. The current Win-style front end is generally good at handling end-of-line markers from other platforms.
:[font = text; inactive; preserveAspect; endGroup; ]
				ASCII Codes		Control Character
	Macintosh		13			^M
	Unix			10			^J
	MS-DOS		13 10			^M^J
:[font = subsubtitle; inactive; preserveAspect; startGroup; Cclosed; nohscroll; center; ]
Porting to Print
:[font = text; inactive; preserveAspect; ]
For some applications, it is useful to create an actual hard-copy document from the notebooks. Several issues peculiar to printing arise in this context.
:[font = text; inactive; preserveAspect; ]
Page breaking is often inappropriate, so you may need to examine the locations of page breaks, and reset them. Currently, this can only be done on a Mac-style front end.
:[font = text; inactive; preserveAspect; endGroup; endGroup; endGroup; ]
Line graphics that use color should be carefully checked; the grayscales that the colors are translated to while printing need to be readily visible on the printed output.
^*)